--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")


local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 1}
local InkedColorsHightlight = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 0.1}

local HightlightTex = "Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsHoverTex"
local PushedTex = "Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsPushedTex"
local CountFont = "Interface\\Addons\\Inked\\Fonts\\SF Comic Script.ttf"
local CountFontSize = 13
local CountFontOutline = "OUTLINE"
local NameFont = "Interface\\Addons\\Inked\\Fonts\\Roboto.ttf"
local NameFontSize = 9
local NameFontOutline = "THINOUTLINE"

local ButtonSize = 40
local MySpacing = 1
local BorderSize = 12
local BorderPadding = 0

local MoverAB8 = CreateFrame("Frame","AB8Drag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	MoverAB8:SetSize((ButtonSize * 12)+12, ButtonSize)
	--MoverAB8:SetPoint("CENTER", UIParent,"BOTTOM",220.5, 65.5)
	MoverAB8:SetFrameStrata("FULLSCREEN_DIALOG")
	MoverAB8:SetClampedToScreen(true)
	MoverAB8:SetClampRectInsets(0, 0, 0,0)
local MoverAB8Text  = MoverAB8:CreateFontString(nil, "OVERLAY")
	MoverAB8Text:SetFont("Interface\\Addons\\Inked\\Fonts\\Cooline.TTF", 15, "OUTLINE")
	MoverAB8Text:SetPoint("CENTER",MoverAB8,"CENTER", 0,0); 
	MoverAB8Text:SetText("")
	
	local function CreateButtonTexture(frame)
	local ButtonForeground = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		  ButtonForeground:SetAllPoints(frame)
		  ButtonForeground:SetFrameLevel(4)
		  ButtonForeground:SetBackdrop({bgFile = "Interface\\Addons\\Inked\\Graphics\\Buttons\\InkedButton",
			edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\InkedBorder",
			edgeSize = 16,
			insets = {top = 4, left = 4, bottom = 4, right = 4}})
		ButtonForeground:SetBackdropColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
		ButtonForeground:SetBackdropBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,0)
end

local function UpdateMe()
	if(Inked.db.profile.lockframes == false) then
		if Inked.db.profile.AB8Enable == true then
			local point, relativeTo, relativePoint, xOfs, yOfs = MoverAB8:GetPoint(n)
				Inked.db.profile.MoverAB8X = xOfs
				Inked.db.profile.MoverAB8Y = yOfs
				Inked.db.profile.MoverAB8Point = point
				--Inked.db.profile.MoverAB8RelPoint = relativePoint
				--print(point.." "..relativePoint)
				MoverAB8Text:SetText("Inked Bar 8")	
		end
	end	
end	

local InkedSettingsFrame = CreateFrame("Frame")	
	InkedSettingsFrame:HookScript("OnUpdate",UpdateMe) 
	
local function CreateMoverBackdrop(frame)
	frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
	insets = {top = -2, left = -2, bottom = -2, right = -2}})
	frame:SetBackdropColor(0,0.55,0.95,0.45)
	frame:SetBackdropBorderColor(0,0,0,1)
end



local function MakeBar8()
if Inked.db.profile.UseActionBars == false then return end
	local InkedBar8 = CreateFrame("Frame", nil, UIParent, BackdropTemplateMixin and "BackdropTemplate")
	InkedBar8:SetAllPoints(MoverAB8)

	ButtonSize = Inked.db.profile.AB8ButtonSize
	local ThisTexture = ("Interface\\Addons\\Inked\\Graphics\\Buttons\\InkedButtons")
		InkedBar8config = {
				outOfRangeColoring = "button",
				tooltip = "enabled",
				showGrid = true,
				colors = {
					range = { 0.8, 0.1, 0.1 },
					mana = { 0.5, 0.5, 1.0 }
				},
				hideElements = {
					macro = false,
					hotkey = false,
					equipped = false,
				},
				keyBoundTarget = false,
				clickOnDown = false,
				flyoutDirection = "UP",	
			}
		CreateFrame("Frame", "InkedActionBar8", UIParent, "SecureHandlerStateTemplate")
		InkedActionBar8:SetParent(InkedBar8)
		InkedActionBar8:SetPoint("RIGHT", InkedBar8,"LEFT",ButtonSize/2,0)
		RegisterStateDriver(InkedActionBar8, "vehicle", "[petbattle][overridebar] hide;show")	
		InkedActionBar8:SetAttribute("_onstate-vehicle", [[
			if newstate == "hide" then
			  self:Hide();
			else
			  self:Show();
			end
		]]) 
		--local ButtonSize = Inked.db.profile.ButtonSize
		--local lastnumber = 85 + Inked.db.profile.Bar7ButtonNumber
			local lastnumber = 85 + 12
			

	if Inked.db.profile.AB8Enable == true then
		InkedBar8:Show()
		if Inked.db.profile.Bar8BarLayout == 1 then
					for i = 85,lastnumber-1 do -- bar 1
						local Inkedbutton8 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar8)
						Inkedbutton8:SetPoint("CENTER", InkedActionBar8,"CENTER",(i-85)*(ButtonSize+MySpacing*1.5),0)
						Inkedbutton8:Show()
						Inkedbutton8:SetState(0, "action", i)
						Inkedbutton8:SetSize(ButtonSize,ButtonSize)
						Inkedbutton8:SetAttribute("buttonlock",true)
						Inkedbutton8:SetAttribute("checkselfcast",true)
						Inkedbutton8:SetAttribute("checkfocuscast",true)
						Inkedbutton8:UpdateConfig(InkedBar8config)
					end
				--	InkedActionBar8:SetPoint("LEFT", InkedBar8,0,0)
				elseif Inked.db.profile.Bar8BarLayout == 2 then
					MoverAB8:SetSize(ButtonSize*6, ButtonSize* 2)
					InkedActionBar8:SetPoint("LEFT", InkedBar8,4,20)
					if lastnumber > 90 then
						for i = 85,90 do -- bar 1
							local Inkedbutton8 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar8)
							Inkedbutton8:SetPoint("CENTER", InkedActionBar8,"CENTER",(i-85)*ButtonSize,0)
							Inkedbutton8:Show()
							Inkedbutton8:SetState(0, "action", i)
							Inkedbutton8:SetSize(ButtonSize,ButtonSize)
							Inkedbutton8:SetAttribute("buttonlock",true)
							Inkedbutton8:SetAttribute("checkselfcast",true)
							Inkedbutton8:SetAttribute("checkfocuscast",true)
							Inkedbutton8:UpdateConfig(InkedBar8config)
						end
						for i = 91,lastnumber-1 do -- bar 1
							local Inkedbutton8a = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar8)
							Inkedbutton8a:SetPoint("CENTER", InkedActionBar8,"CENTER",(i-91)*ButtonSize,-(ButtonSize+1))
							Inkedbutton8a:Show()
							Inkedbutton8a:SetState(0, "action", i)
							Inkedbutton8a:SetSize(ButtonSize,ButtonSize)
							Inkedbutton8a:SetAttribute("buttonlock",true)
							Inkedbutton8a:SetAttribute("checkselfcast",true)
							Inkedbutton8a:SetAttribute("checkfocuscast",true)
							Inkedbutton8a:UpdateConfig(InkedBar8config)
						end
					else
						for i = 85,lastnumber-1 do -- bar 1
							local Inkedbutton8 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar8)
							Inkedbutton8:SetPoint("CENTER", InkedActionBar8,"CENTER",(i-85)*ButtonSize,0)
							Inkedbutton8:Show()
							Inkedbutton8:SetState(0, "action", i)
							Inkedbutton8:SetSize(ButtonSize,ButtonSize)
							Inkedbutton8:SetAttribute("buttonlock",true)
							Inkedbutton8:SetAttribute("checkselfcast",true)
							Inkedbutton8:SetAttribute("checkfocuscast",true)
							Inkedbutton8:UpdateConfig(InkedBar8config)
						end					
					end
							
				elseif Inked.db.profile.Bar8BarLayout == 3 then
					MoverAB8:SetSize(ButtonSize*4, ButtonSize* 3)
					InkedActionBar8:SetPoint("LEFT", InkedBar8,8,33)
					if lastnumber > 88 then
						for i = 85,88 do -- bar 1
							local Inkedbutton8 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar8)
							Inkedbutton8:SetPoint("CENTER", InkedActionBar8,"CENTER",(i-85)*ButtonSize,0)
							Inkedbutton8:Show()
							Inkedbutton8:SetState(0, "action", i)
							Inkedbutton8:SetSize(ButtonSize,ButtonSize)
							Inkedbutton8:SetAttribute("buttonlock",true)
							Inkedbutton8:SetAttribute("checkselfcast",true)
							Inkedbutton8:SetAttribute("checkfocuscast",true)
							Inkedbutton8:UpdateConfig(InkedBar8config)
						end
						for i = 89,92 do -- bar 1
							local Inkedbutton8a = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar8)
							Inkedbutton8a:SetPoint("CENTER", InkedActionBar8,"CENTER",(i-89)*ButtonSize,-(ButtonSize+1))
							Inkedbutton8a:Show()
							Inkedbutton8a:SetState(0, "action", i)
							Inkedbutton8a:SetSize(ButtonSize,ButtonSize)
							Inkedbutton8a:SetAttribute("buttonlock",true)
							Inkedbutton8a:SetAttribute("checkselfcast",true)
							Inkedbutton8a:SetAttribute("checkfocuscast",true)
							Inkedbutton8a:UpdateConfig(InkedBar8config)
						end
						for i = 93,lastnumber-1 do -- bar 1
							local Inkedbutton8b = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar8)
							Inkedbutton8b:SetPoint("CENTER", InkedActionBar8,"CENTER",(i-93)*ButtonSize,-(ButtonSize+1)*2)
							Inkedbutton8b:Show()
							Inkedbutton8b:SetState(0, "action", i)
							Inkedbutton8b:SetSize(ButtonSize,ButtonSize)
							Inkedbutton8b:SetAttribute("buttonlock",true)
							Inkedbutton8b:SetAttribute("checkselfcast",true)
							Inkedbutton8b:SetAttribute("checkfocuscast",true)
							Inkedbutton8b:UpdateConfig(InkedBar8config)
						end
					else
						for i = 85,lastnumber-1 do -- bar 1
							local Inkedbutton8 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar8)
							Inkedbutton8:SetPoint("CENTER", InkedActionBar8,"CENTER",(i-85)*ButtonSize,0)
							Inkedbutton8:Show()
							Inkedbutton8:SetState(0, "action", i)
							Inkedbutton8:SetSize(ButtonSize,ButtonSize)
							Inkedbutton8:SetAttribute("buttonlock",true)
							Inkedbutton8:SetAttribute("checkselfcast",true)
							Inkedbutton8:SetAttribute("checkfocuscast",true)
							Inkedbutton8:UpdateConfig(InkedBar8config)
						end					
					end
				
				elseif Inked.db.profile.Bar8BarLayout == 4 then
					InkedActionBar8:SetPoint("TOPLEFT", InkedBar8,"BOTTOMRIGHT",-15,15)
					MoverAB8:SetSize(ButtonSize, ButtonSize* 12)
					for i = 85,lastnumber-1 do -- bar 1
						local Inkedbutton8 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar8)
						Inkedbutton8:SetPoint("CENTER", InkedActionBar8,"CENTER",0,(i-85)*ButtonSize)
						Inkedbutton8:Show()
						Inkedbutton8:SetState(0, "action", i)
						Inkedbutton8:SetSize(ButtonSize,ButtonSize)
						Inkedbutton8:SetAttribute("buttonlock",true)
						Inkedbutton8:SetAttribute("checkselfcast",true)
						Inkedbutton8:SetAttribute("checkfocuscast",true)
						Inkedbutton8:UpdateConfig(InkedBar8config)
					end
				elseif Inked.db.profile.Bar8BarLayout == 5 then
					MoverAB8:SetSize(ButtonSize*2, ButtonSize* 6)
					InkedActionBar8:SetPoint("TOPLEFT", InkedBar8,"BOTTOMRIGHT",10,15)
					if lastnumber > 90 then
						for i = 85,90 do -- bar 1
							local Inkedbutton8 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar8)
							Inkedbutton8:SetPoint("CENTER", InkedActionBar8,"CENTER",0,(i-85)*ButtonSize)
							Inkedbutton8:Show()
							Inkedbutton8:SetState(0, "action", i)
							Inkedbutton8:SetSize(ButtonSize,ButtonSize)
							Inkedbutton8:SetAttribute("buttonlock",true)
							Inkedbutton8:SetAttribute("checkselfcast",true)
							Inkedbutton8:SetAttribute("checkfocuscast",true)
							Inkedbutton8:UpdateConfig(InkedBar8config)
						end
						for i = 91,lastnumber-1 do -- bar 1
							local Inkedbutton8a = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar8)
							Inkedbutton8a:SetPoint("CENTER", InkedActionBar8,"CENTER",-ButtonSize,(i-91)*ButtonSize)
							Inkedbutton8a:Show()
							Inkedbutton8a:SetState(0, "action", i)
							Inkedbutton8a:SetSize(ButtonSize,ButtonSize)
							Inkedbutton8a:SetAttribute("buttonlock",true)
							Inkedbutton8a:SetAttribute("checkselfcast",true)
							Inkedbutton8a:SetAttribute("checkfocuscast",true)
							Inkedbutton8a:UpdateConfig(InkedBar8config)
						end
					else
						for i = 85,lastnumber-1 do -- bar 1
							local Inkedbutton8 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar8)
							Inkedbutton8:SetPoint("CENTER", InkedActionBar8,"CENTER",(i-85)*ButtonSize,0)
							Inkedbutton8:Show()
							Inkedbutton8:SetState(0, "action", i)
							Inkedbutton8:SetSize(ButtonSize,ButtonSize)
							Inkedbutton8:SetAttribute("buttonlock",true)
							Inkedbutton8:SetAttribute("checkselfcast",true)
							Inkedbutton8:SetAttribute("checkfocuscast",true)
							Inkedbutton8:UpdateConfig(InkedBar8config)
						end					
					end
				
				elseif Inked.db.profile.Bar8BarLayout == 6 then
					MoverAB8:SetSize(ButtonSize*3, ButtonSize*4)
					InkedActionBar8:SetPoint("LEFT", InkedBar8,10,52)
					if lastnumber > 87 then
						for i = 85,87 do -- bar 1
							local Inkedbutton8 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar8)
							Inkedbutton8:SetPoint("CENTER", InkedActionBar8,"CENTER",(i-85)*ButtonSize,0)
							Inkedbutton8:Show()
							Inkedbutton8:SetState(0, "action", i)
							Inkedbutton8:SetSize(ButtonSize,ButtonSize)
							Inkedbutton8:SetAttribute("buttonlock",true)
							Inkedbutton8:SetAttribute("checkselfcast",true)
							Inkedbutton8:SetAttribute("checkfocuscast",true)
							Inkedbutton8:UpdateConfig(InkedBar8config)
						end
						for i = 88,90 do -- bar 1
							local Inkedbutton8a = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar8)
							Inkedbutton8a:SetPoint("CENTER", InkedActionBar8,"CENTER",(i-88)*ButtonSize,-(ButtonSize+1))
							Inkedbutton8a:Show()
							Inkedbutton8a:SetState(0, "action", i)
							Inkedbutton8a:SetSize(ButtonSize,ButtonSize)
							Inkedbutton8a:SetAttribute("buttonlock",true)
							Inkedbutton8a:SetAttribute("checkselfcast",true)
							Inkedbutton8a:SetAttribute("checkfocuscast",true)
							Inkedbutton8a:UpdateConfig(InkedBar8config)
						end
						for i = 91,93 do -- bar 1
							local Inkedbutton8b = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar8)
							Inkedbutton8b:SetPoint("CENTER", InkedActionBar8,"CENTER",(i-91)*ButtonSize,-(ButtonSize+1)*2)
							Inkedbutton8b:Show()
							Inkedbutton8b:SetState(0, "action", i)
							Inkedbutton8b:SetSize(ButtonSize,ButtonSize)
							Inkedbutton8b:SetAttribute("buttonlock",true)
							Inkedbutton8b:SetAttribute("checkselfcast",true)
							Inkedbutton8b:SetAttribute("checkfocuscast",true)
							Inkedbutton8b:UpdateConfig(InkedBar8config)
						end
						for i = 94,lastnumber-1 do -- bar 1
							local Inkedbutton8c = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar8)
							Inkedbutton8c:SetPoint("CENTER", InkedActionBar8,"CENTER",(i-94)*ButtonSize,-(ButtonSize+1)*3)
							Inkedbutton8c:Show()
							Inkedbutton8c:SetState(0, "action", i)
							Inkedbutton8c:SetSize(ButtonSize,ButtonSize)
							Inkedbutton8c:SetAttribute("buttonlock",true)
							Inkedbutton8c:SetAttribute("checkselfcast",true)
							Inkedbutton8c:SetAttribute("checkfocuscast",true)
							Inkedbutton8c:UpdateConfig(InkedBar8config)
						end
					else
						for i = 85,lastnumber-1 do -- bar 1
							local Inkedbutton8 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar8)
							Inkedbutton8:SetPoint("CENTER", InkedActionBar8,"CENTER",(i-85)*ButtonSize,0)
							Inkedbutton8:Show()
							Inkedbutton8:SetState(0, "action", i)
							Inkedbutton8:SetSize(ButtonSize,ButtonSize)
							Inkedbutton8:SetAttribute("buttonlock",true)
							Inkedbutton8:SetAttribute("checkselfcast",true)
							Inkedbutton8:SetAttribute("checkfocuscast",true)
							Inkedbutton8:UpdateConfig(InkedBar8config)
						end					
					end
				
				end -- end folds
					for i = 85,96 do -- bar 6
							local normalBar8 = _G["InkedbuttonBar"..i]							
						--	CreateButtonTexture(normalBar8)
							normalBar8.NormalTexture:SetTexture("")
							local Highlight = normalBar8:GetHighlightTexture()						
							local Pushed = normalBar8:GetPushedTexture()
							Highlight:SetTexture(HightlightTex)
							Highlight:SetVertexColor(InkedColorsHightlight.r,InkedColorsHightlight.g,InkedColorsHightlight.b,InkedColorsHightlight.a)
							Pushed:SetTexture(PushedTex)							
							local count = _G[normalBar8:GetName()..'Count']
							count:SetFont(CountFont,CountFontSize,CountFontOutline)
							local name = _G[normalBar8:GetName()..'Name']
							name:SetWidth(55)
							name:SetFont(NameFont,NameFontSize,NameFontOutline)
							normalBar8:CreateBeautyBorder(BorderSize)
							normalBar8:SetBeautyBorderPadding(BorderPadding)
							normalBar8:SetBeautyBorderTexture("white")
							--normalBar8:SetBeautyBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
							if Inked.db.profile.ClassABColor == true then
								normalBar8:SetBeautyBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
							elseif Inked.db.profile.ClassABColor == false then
								if Inked.db.profile.CustomABColor == true then
									normalBar8:SetBeautyBorderColor(Inked.db.profile.ABColorR,Inked.db.profile.ABColorG,Inked.db.profile.ABColorB,Inked.db.profile.ABColorA)
								elseif Inked.db.profile.CustomABColor == false then
									normalBar8:SetBeautyBorderColor(1,1,1,1)
								end
							end
		
						end
		end
		if(Inked.db.profile.lockframes == false) then
			MoverAB8:ClearAllPoints()
			if Inked.db.profile.MoverAB8Point == nil then
				MoverAB8:SetPoint("BOTTOM", UIParent,Inked.db.profile.MoverAB8X,Inked.db.profile.MoverAB8Y)
			else
				MoverAB8:SetPoint(Inked.db.profile.MoverAB8Point, UIParent,Inked.db.profile.MoverAB8X,Inked.db.profile.MoverAB8Y)
			end
			if Inked.db.profile.AB8Enable == true then
				CreateMoverBackdrop(MoverAB8)
				MoverAB8:SetMovable(true)
				MoverAB8:EnableMouse(true)
				MoverAB8:RegisterForDrag("LeftButton")
				MoverAB8:SetScript("OnDragStart", MoverAB8.StartMoving)
				MoverAB8:SetScript("OnDragStop", MoverAB8.StopMovingOrSizing)
				MoverAB8:SetUserPlaced(true)
			end
			elseif Inked.db.profile.MoverAB8Point == nil then
				MoverAB8:SetPoint("BOTTOM", UIParent,Inked.db.profile.MoverAB8X,Inked.db.profile.MoverAB8Y)
			else
				MoverAB8:SetPoint(Inked.db.profile.MoverAB8Point, UIParent,Inked.db.profile.MoverAB8X,Inked.db.profile.MoverAB8Y)
		end
end		
		local InkedLoginFrame=CreateFrame("Frame")
		InkedLoginFrame:RegisterEvent("PLAYER_LOGIN")
		InkedLoginFrame:RegisterEvent("CINEMATIC_STOP")
		InkedLoginFrame:SetScript("OnEvent", function(self, event) 
			MakeBar8()									
		end)